org.jgroups.protocols

## Class DISCARD

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.DISCARD

    public class DISCARD
    extends Protocol

Discards up or down messages based on a percentage; e.g., setting property 'up' to 0.1 causes 10% of all up messages to be discarded. Setting 'down' or 'up' to 0 causes no loss, whereas 1 discards all messages (not very useful).

### Nested Class Summary

Nested Classes
`static class` `DISCARD.DiscardHeader`

### Field Summary

Fields
`protected boolean` `use_gui`

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`DISCARD()`

### Method Summary

Methods
`void` `addIgnoreMember(Address sender)` Messages from this sender will get dropped
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`double` `getDownDiscardRate()`
`int` `getDropDownMulticasts()`
`int` `getDropDownUnicasts()`
`double` `getUpDiscardRate()`
`boolean` `isDiscardAll()`
`boolean` `isExcludeItself()`
`void` `removeIgnoredMember(Address member)`
`void` `resetIgnoredMembers()`
`void` `resetStats()`
`void` `setDiscardAll(boolean discard_all)`
`void` `setDownDiscardRate(double down)`
`void` `setDropDownMulticasts(int drop_down_multicasts)`
`void` `setDropDownUnicasts(int drop_down_unicasts)` Drop the next N unicasts down the stack
`void` `setExcludeItself(boolean excludeItself)`
`void` `setLocalAddress(Address localAddress)`
`void` `setUpDiscardRate(double up)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`void` `startGui()`
`void` `stop()` This method is called on a `Channel.disconnect()`.
`void` `stopGui()`
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, init, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### use_gui

    protected boolean use_gui

### Constructor Detail

#### DISCARD

    public DISCARD()

### Method Detail

#### isDiscardAll

    public boolean isDiscardAll()

#### setDiscardAll

    public void setDiscardAll(boolean discard_all)

#### isExcludeItself

    public boolean isExcludeItself()

#### setLocalAddress

    public void setLocalAddress(Address localAddress)

#### setExcludeItself

    public void setExcludeItself(boolean excludeItself)

#### getUpDiscardRate

    public double getUpDiscardRate()

#### setUpDiscardRate

    public void setUpDiscardRate(double up)

#### getDownDiscardRate

    public double getDownDiscardRate()

#### setDownDiscardRate

    public void setDownDiscardRate(double down)

#### getDropDownUnicasts

    public int getDropDownUnicasts()

#### setDropDownUnicasts

    public void setDropDownUnicasts(int drop_down_unicasts)

Drop the next N unicasts down the stack

Parameters:
  `drop_down_unicasts` -

#### getDropDownMulticasts

    public int getDropDownMulticasts()

#### setDropDownMulticasts

    public void setDropDownMulticasts(int drop_down_multicasts)

#### addIgnoreMember

    public void addIgnoreMember(Address sender)

Messages from this sender will get dropped

#### removeIgnoredMember

    public void removeIgnoredMember(Address member)

#### resetIgnoredMembers

    public void resetIgnoredMembers()

#### startGui

    public void startGui()

#### stopGui

    public void stopGui()

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### resetStats

    public void resetStats()

Overrides:
  `resetStats` in class `Protocol`